package org.dromara.work.service;

import com.alibaba.fastjson.JSONObject;
import com.github.yulichang.base.MPJBaseService;
import jakarta.validation.constraints.NotNull;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpOrder;
import org.dromara.work.domain.TpOrderPay;
import org.dromara.work.domain.bo.TpAppealsBo;
import org.dromara.work.domain.bo.TpOrderBo;
import org.dromara.work.domain.vo.*;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;

/**
 * 订单管理Service接口
 *
 * @author Maosw
 * @date 2024-08-12
 */
public interface ITpOrderService extends MPJBaseService<TpOrder> {

    /**
     * 查询订单管理
     *
     * @param id 主键
     * @return 订单管理
     */
    TpOrderVo queryById(Long id);

    /**
     * 分页查询订单管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 订单管理分页列表
     */
    TableDataInfo<TpOrderVo> queryPageList(TpOrderBo bo, PageQuery pageQuery);

    /**
     * 新增订单管理
     *
     * @param bo 订单管理
     * @return 是否新增成功
     */
    Boolean insertByBo(TpOrderBo bo);

    /**
     * 修改订单管理
     *
     * @param bo 订单管理
     * @return 是否修改成功
     */
    Boolean updateByBo(TpOrderBo bo);

    /**
     * 校验并批量删除订单管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 查询订单管理(客服)
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<CustomerOrderVo> queryCustomerPageList(TpOrderBo bo, PageQuery pageQuery);

    /**
     * 查询订单管理(技术)
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<SkillOrderVo> querySkillPageList(TpOrderBo bo, PageQuery pageQuery);

    /**
     * 查询订单统计（客服）
     * @param bo
     * @return
     */
    CustomerOrderSumVo queryCustomerSum(TpOrderBo bo);

    /**
     *查询订单统计（技术）
     * @param bo
     * @return
     */
    SkillOrderSumVo querySkillSum(TpOrderBo bo);

    /**
     * 订单指派技术
     * @param orderIds
     * @param userId
     * @return
     */
    boolean updateOrderAssign(List<Long> orderIds, Long userId);

    /**
     * 订单取消指派
     * @param orderId
     * @return
     */
    int orderCancelAssign(Long orderId);

    /**
     * 订单支付获取订单和余额信息
     * @param orderId
     * @return
     */
    TpOrderVo queryOrderPay(Long orderId);

    /**
     * 订单支付
     * @param orderId
     * @param type
     * @param price
     * @return
     */
    JSONObject orderPay(Long orderId, Integer type, BigDecimal price) throws Exception;

    /**
     * 订单回退获取订单和退款金额信息
     * @param orderId
     * @return
     */
    TpOrderVo orderFallback(Long orderId);

    /**
     * 订单回退
     * @param orderId
     * @param type
     * @param price
     * @return
     */
    int fallback(Long orderId, Integer type, BigDecimal price);

    /**
     * 订单拆单获取订单和金额信息
     * @param orderId
     * @return
     */
    TpOrderVo cdOrderInfo(Long orderId);

    /**
     * 订单拆单
     * @param orderId
     * @param price
     * @return
     */
    int cdOrder(Long orderId, BigDecimal price);

    /**
     * 订单改价获取订单和金额信息
     * @param orderId 主键
     */
    TpOrderVo gjOrderInfo(Long orderId);

    /**
     * 订单改价
     */
    int gjOrder(Long orderId, BigDecimal price);

    /**
     * 导出客服订单
     * @param bo
     * @return
     */
    List<TpOrderVo> queryListKF(TpOrderBo bo);

    /**
     * 导出技术订单
     * @param bo
     * @return
     */
    List<TpOrderVo> queryListJS(TpOrderBo bo);

    /**
     * 回收站导出订单
     * @param bo
     * @return
     */
    List<TpOrderVo> queryList(TpOrderBo bo);

    /**
     * 支付回调处理订单信息
     * @param id
     * @param tradeNo
     * @param logNo
     * @param respData
     * @return
     */
    Boolean callbackOrder(Long id, TpOrderPay orderPay, String tradeNo, String logNo, JSONObject respData);

    /**
     * 技术人员订单取消
     * @param id
     * @return
     */
    Boolean jsOrderFallback(Long id);

    /**
     * 订单取消
     * @param id
     * @return
     */
    Boolean orderCancel(Long id);

    /**
     * 订单退款
     * @param id
     * @return
     */
    Boolean orderRefund(Long id);

    /**
     * 技术人员订单处理退款
     * @param bo
     * @return
     */
    Boolean orderRefundJs(TpOrderBo bo);

    /**
     * 订单确认
     * @param id
     * @return
     */
    Boolean orderConfirm(@NotNull(message = "主键不能为空") Long id);


    /**
     * 订单统计
     * @param userId
     * @return
     */
    OrderCountVo orderCount(@NotNull(message = "主键不能为空") Long userId);

    /**
     * 订单接单
     * @param id
     * @return
     */
    Boolean orderAccept(@NotNull(message = "主键不能为空") Long id, Long userId);

    /**
     * 订单评价
     * @param bo
     * @return
     */
    Boolean addComment(TpAppealsBo bo);

    /**
     * 订单取消退款
     * @param id
     * @return
     */
    Boolean orderCancelRefund(@NotNull(message = "主键不能为空") Long id);
}
